summaryrefslogtreecommitdiff
path: root/tests
diff options
context:
space:
mode:
authorJim Meyering <meyering@redhat.com>2009-11-03 14:30:56 +0100
committerJim Meyering <meyering@redhat.com>2009-11-03 14:48:10 +0100
commitd4b96c26ce0e79cb64fc99dda56d795765d5656d (patch)
tree72f2990280b12d2e5051f3285f6fe4725bc70844 /tests
parent7bf2e3db23bd0a9ed59d95a683edd188fa52a033 (diff)
downloadcoreutils-d4b96c26ce0e79cb64fc99dda56d795765d5656d.tar.xz
tests: rm: add test for today's change in behavior
* tests/Makefile.am (root_tests): Add rm/read-only to the list. * tests/rm/read-only: New file.
Diffstat (limited to 'tests')
-rw-r--r--tests/Makefile.am1
-rwxr-xr-xtests/rm/read-only56
2 files changed, 57 insertions, 0 deletions
diff --git a/tests/Makefile.am b/tests/Makefile.am
index eec31aed1..f67b796d2 100644
--- a/tests/Makefile.am
+++ b/tests/Makefile.am
@@ -37,6 +37,7 @@ root_tests = \
rm/fail-2eperm \
rm/no-give-up \
rm/one-file-system \
+ rm/read-only \
tail-2/append-only \
touch/now-owned-by-other
diff --git a/tests/rm/read-only b/tests/rm/read-only
new file mode 100755
index 000000000..3c83aad15
--- /dev/null
+++ b/tests/rm/read-only
@@ -0,0 +1,56 @@
+#!/bin/sh
+# Ensure that rm -f nonexistent-file-on-read-only-fs succeeds.
+
+# Copyright (C) 2009 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+if test "$VERBOSE" = yes; then
+ set -x
+ rm --version
+fi
+
+. $srcdir/test-lib.sh
+require_root_
+
+cwd=`pwd`
+cleanup_() { cd /; umount "$cwd/mnt"; }
+
+skip=0
+# Create a file system, then mount it.
+dd if=/dev/zero of=blob bs=8192 count=200 > /dev/null 2>&1 \
+ || skip=1
+mkdir mnt || skip=1
+mkfs -t ext2 -F blob \
+ || skip_test_ "failed to create ext2 file system"
+
+mount -oloop blob mnt || skip=1
+echo test > mnt/f || skip=1
+test -s mnt/f || skip=1
+mount -o remount,loop,ro mnt || skip=1
+
+test $skip = 1 \
+ && skip_test_ "insufficient mount/ext2 support"
+
+# Applying rm -f to a nonexistent file on a read-only file system must succeed.
+rm -f mnt/no-such > out 2>&1 || fail=1
+# It must produce no diagnostic.
+test -s out && fail=1
+
+# However, trying to remove an existing file must fail.
+rm -f mnt/f > out 2>&1 && fail=1
+# with a diagnostic.
+test -s out || fail=1
+
+Exit $fail